#!ruby -Ks
# -*- mode: ruby; encoding: sjis -*-
# Last updated: <2014/05/29 06:35:00 +0900>

require 'dxruby'
require_relative 'xiaolinwu'

#
# `悷NX
#
class LineDraw

  # `
  #
  # @param [Object] img `ΏۂImageIuWFNg
  # @param [Number] x1 n_ x
  # @param [Number] y1 n_ y
  # @param [Number] x2 I_ x
  # @param [Number] y2 I_ y
  # @param [Array] col `Fz A,R,G,B
  # @param [Number] linew 
  # @param [Number] aa A`GCAX̕
  # @param [Number] last_t O`掞̗]l
  # @param [Boolean] aa2 trueȂꍇA`GCAX邪x
  # @param [Boolean] edge_only trueȂGbŴݕ`BmFp
  # @return [Number] `掞̗]l
  #
  def LineDraw.draw(img, x1, y1, x2, y2, col, linew = 1,
                    aa = 1, last_t = 0, aa2 = false, edge_only = false)
    ret = 0
    if linew <= 1
      #  = 1 ̎

      if aa <= 1
        # A`GCAX
        LineDraw.draw_dda(img, x1, y1, x2, y2, col)
        # img.line(x1, y1, x2, y2, col)
      else
        # A`GCAXL
        XiaolinWuDraw.draw_line(img, x1, y1,x2, y2, col)
      end
    else
      #  > 1 ̎

      if aa2
        # A`GCAXLŕ`Bx
        ret = LineDraw.draw_aa(img, x1, y1, x2, y2, col, linew, aa, last_t)
      else
        # A`GCAXŕ`

        # Op`|S{~hԂŕ`
        ret = LineDraw.draw_poly(img, x1, y1, x2, y2, col, linew, edge_only)

        # uVŕ`
        # ret = LineDraw.draw_brush(img, x1, y1, x2, y2, col, linew, last_t)
      end
    end
    return ret
  end

  # ----------------------------------------
  # DDAŕ`BA`GCAX
  #
  # @note ȉQly[W
  #       DDAɂE~̕`R
  #       http://www7.plala.or.jp/nekogrammer/dda/DDA3.htm
  #
  # @param [Object] img `ΏۂImageIuWFNg
  # @param [Number] x1 n_ x
  # @param [Number] y1 n_ y
  # @param [Number] x2 I_ x
  # @param [Number] y2 I_ y
  # @param [Array] col `FzBA,R,G,B
  #
  def LineDraw.draw_dda(img, x1, y1, x2, y2, col)
    x1 = x1.to_i
    y1 = y1.to_i
    x2 = x2.to_i
    y2 = y2.to_i
    dx = x2 - x1
    dy = y2 - y1
    a = dx.abs
    b = dy.abs
    xadd = LineDraw.get_sign(dx)
    yadd = LineDraw.get_sign(dy)
    x, y = x1, y1
    if a >= b
      # x̂ق傫
      e = dy.abs * -1
      fg = true
      while fg
        img[x, y] = col
        break if x == x2
        x += xadd
        e += 2 * b
        if e >= 0
          y += yadd
          e -= 2 * a
        end
      end
    else
      # ŷق傫
      e = dx.abs * -1
      fg = true
      while fg
        img[x, y] = col
        break if y == y2
        y += yadd
        e += 2 * a
        if e >= 0
          x += xadd
          e -= 2 * b
        end
      end
    end
    return 0
  end

  def LineDraw.get_sign(x)
    return 0 if x == 0
    return -1 if x < 0
    return 1
  end

  # ----------------------------------------
  # uV摜ŕ`
  #
  # @param [Object] img `ΏۂImageIuWFNg
  # @param [Number] x1 n_ x
  # @param [Number] y1 n_ y
  # @param [Number] x2 I_ x
  # @param [Number] y2 I_ y
  # @param [Array] col `Fz A,R,G,B
  # @param [Number] linew 
  # @param [Number] last_t O`掞̗]l
  # @param [Number] line_interval `Ԋu
  # @return [Number] `掞̗]l
  #
  def LineDraw.draw_brush(img, x1, y1, x2, y2, col, linew,
                          last_t = 0, line_interval = 0.2)

    brush = LineDraw.get_brush_image(col, linew, aa = 4)
    dx = (x2 - x1).to_f
    dy = (y2 - y1).to_f
    len = Math.sqrt(dx * dx + dy * dy)
    return if len == 0
    ti = line_interval / len
    t = last_t / len
    r = brush.width / 2
    while t < 1.0
      x = dx * t + x1 - r
      y = dy * t + y1 - r
      img.draw(x, y, brush)
      dt = r * ti
      dt = 0.0001 if dt < 0.0001
      t += dt
    end
    last_t = len * (t - 1.0)
    brush.dispose
    return last_t
  end

  # `p̃uVImage擾
  #
  # @param [Array] col uVF
  # @param [Number] linew 
  # @param [Number] aa A`GCAXl
  # @return [Object] uVpImage
  #
  def LineDraw.get_brush_image(col, linew, aa = 9)
    w, h = linew, linew
    r = linew / 2.0
    if w <= 0 or h <= 0
      w, h = 1, 1
      r = 0.5
    end
    img = Image.new(w, h)
    rr = r * r
    aad = aa * aa
    0.step(h, 1.0) do |y|
      0.step(w, 1.0) do |x|
        v = 0
        aa.times do |jy|
          yy = jy * (1.0 / aa) + y - r
          aa.times do |jx|
            xx = jx * (1.0 / aa) + x - r
            d = (xx * xx + yy * yy) / rr
            v += (1.0 - d) if d < 1.0
          end
        end
        a = col[0] * v.to_f / aad
        img[x, y] = [a, col[1], col[2], col[3]]
      end
    end
    return img
  end

  # ----------------------------------------
  # A`GCAXLŕ`
  #
  # @note ȉQly[W
  #       A`GCAXt̎R`(1)
  #       http://azskyetc.client.jp/paintprog/025_aaline1.html
  #
  # @param [Object] img `ΏۂImageIuWFNg
  # @param [Number] x1 n_ x
  # @param [Number] y1 n_ y
  # @param [Number] x2 I_ x
  # @param [Number] y2 I_ y
  # @param [Array] col `Fz A,R,G,B
  # @param [Number] linew 
  # @param [Number] aa A`GCAX̕
  # @param [Number] last_t O`掞̗]l
  # @param [Number] line_interval `Ԋu
  # @return [Number] `掞̗]l
  #
  def LineDraw.draw_aa(img, x1, y1, x2, y2, col, linew,
                       aa = 4, last_t = 0, line_interval = 0.25)
    dx = (x2 - x1).to_f
    dy = (y2 - y1).to_f
    len = Math.sqrt(dx * dx + dy * dy)
    return if len == 0
    ti = line_interval / len
    t = last_t / len
    while t < 1.0
      x = dx * t + x1
      y = dy * t + y1
      LineDraw.draw_point(img, x, y, col, linew, aa)
      dt = linew * ti
      dt = 0.0001 if dt < 0.0001
      t += dt
    end
    last_t = len * (t - 1.0)
    return last_t
  end

  # A`GCAXtŉ~`
  #
  # @param [Object] img ImageIuWFNg
  # @param [Number] px xW
  # @param [Number] py yW
  # @param [Array] col `FzBA,R,G,B
  # @param [Number] linew 
  # @param [Number] aa A`GCAX̕
  #
  def LineDraw.draw_point(img, px, py, col, linew, aa = 4)
    r = linew / 2.0
    x1, y1 = (px - r).floor, (py - r).floor
    x2, y2 = (px + r).ceil, (py + r).ceil
    rr = r * r
    aad = aa * aa
    cc = [255, col[1].to_i, col[2].to_i, col[3].to_i]
    for y in y1..y2
      for x in x1..x2
        next if img.compare(x,y,cc)

        v = 0.0
        xa = x - px
        ya = y - py
        for jy in 0..aa
          yy = ya + (jy.to_f / aa)
          for jx in 0..aa
            xx = xa + (jx.to_f / aa)
            d = (xx * xx + yy * yy) / rr
            v += (1.0 - d) if d < 1.0
          end
        end
        ao = col[0] * v / aad
        ao = 0 if ao < 0
        ao = 255.0 if ao > 255.0

        s = img[x,y]
        s[0] = (s[0] > ao)? s[0] : ao
        a = ao / 255.0
        ma = 1.0 - a
        s[1] = s[1] * ma + cc[1] * a
        s[2] = s[2] * ma + cc[2] * a
        s[3] = s[3] * ma + cc[3] * a
        img[x,y] = s
      end
    end
  end

  # ----------------------------------------
  # Op`hԂƉ~hԂgĒ`
  #
  # @note {̂Op`hԂ2gĕ`Bn_ƏI_͉~hԂŕ`B
  #
  # @param [Object] img `ΏۂImageIuWFNg
  # @param [Number] x1 n_ x
  # @param [Number] y1 n_ y
  # @param [Number] x2 I_ x
  # @param [Number] y2 I_ y
  # @param [Array] col `Fz A,R,G,B
  # @param [Number] linew 
  # @param [Boolean] edge_only trueȂGbŴݕ`BmFp
  # @return [Number] `ŗ]l
  #
  def LineDraw.draw_poly(img, x1, y1, x2, y2, col, linew, edge_only = false)
    r = linew / 2.0
    dx = x2 - x1
    dy = y2 - y1
    rad = Math.atan2(dy, dx) + (Math::PI / 2.0)
    xd = r * Math.cos(rad)
    yd = r * Math.sin(rad)

    # A܂A`4_߂
    np = []
    np.push([x1 + xd, y1 + yd])
    np.push([x2 + xd, y2 + yd])
    np.push([x2 - xd, y2 - yd])
    np.push([x1 - xd, y1 - yd])

    if edge_only
      # GbW`悵ēmF
      np.size.times do |i|
        x3, y3 = np[i]
        x4, y4 = np[(i+1) % np.size]
        img.line(x3, y3, x4, y4, col)
      end
      img.circle(x1, y1, r, col)
      img.circle(x2, y2, r, col)
    else
      # hׂ

      # Op`hԂ2
      img.triangleFill(np[0][0], np[0][1], np[1][0], np[1][1],
                       np[2][0], np[2][1], col)
      img.triangleFill(np[2][0], np[2][1], np[3][0], np[3][1],
                       np[0][0], np[0][1], col)
      # n_ƏI_~œhԂ
      img.circleFill(x1, y1, r, col)
      img.circleFill(x2, y2, r, col)
    end

    return 0
  end

end

if $0 == __FILE__
  # ----------------------------------------
  # eXg

  font = Font.new(14)
  img = Image.new(640, 480)
  col = [255, 0, 255, 0]
  p = [
    [
      [58.15, 39.0],
      [58.15, 230.1],
      [171.1, 230.1],
      [171.1, 39.0],
      [58.15, 39.0]
    ],
    [
      [20.0, 240.0],
      [100.0, 300.0],
      [600.0, 400.0]
    ]
  ]

  linew = 1
  aa = 1
  aa2 = false
  list_kind = 0
  point_mv = false
  edge_only = false

  # Window.scale = 2
  Window.bgcolor = [128, 128, 128]

  Window.loop do
    break if Input.keyPush?(K_ESCAPE)

    # EL[œhԂ/GbŴݕ`ؑ
    edge_only = !edge_only if Input.keyPush?(K_E)

    # ㉺L[ŐύX
    linew += 0.5 if Input.keyPush?(K_UP)
    linew -= 0.5 if Input.keyPush?(K_DOWN)
    linew = 1 if linew < 1

    # AL[ŁAuV`/A`GCAX`̐؂ւ
    aa = ((aa == 1)? 3 : 1) if Input.keyPush?(K_A)

    # SL[ŁAA`GCAX`
    aa2 = !aa2 if Input.keyPush?(K_S)

    # KL[ŁAWzؑ
    list_kind = (list_kind + 1) % p.size if Input.keyPush?(K_K)

    # ML[ŁAW̃}EXړؑ
    point_mv = !point_mv if Input.keyPush?(K_M)
    if point_mv
      p[list_kind][1][0] = Input.mousePosX
      p[list_kind][1][1] = Input.mousePosY
    end

    img.clear
    (p[list_kind].size - 1).times do |i|
      x0, y0 = p[list_kind][i]
      x1, y1 = p[list_kind][(i+1) % p[list_kind].size]
      LineDraw.draw(img, x0, y0, x1, y1, col, linew,
                    aa, 0, aa2, edge_only)
    end

    Window.draw(0, 0, img)

    s = "LineWidth=#{linew}  #{Window.real_fps} FPS  CPU: #{Window.getLoad.to_i}%"
    Window.drawFont(8, 2, s, font)
    s = "A , S , K , E , M , up , down key"
    Window.drawFont(8, 16, s, font)
  end
end
