#!ruby -Ks
# -*- mode: ruby; encoding: sjis -*-
# Last updated: <2014/05/29 06:24:33 +0900>

require 'dxruby'

# ^ꂽp`œhԂNX
#
# @note ȉ̃y[WQlɂ܂B
#       p`hԂ(1)
#       http://azskyetc.client.jp/paintprog/031_polygon1.html
#
class PolyFill

  # hׂ
  #
  # @param [Object] img ImageIuWFNg
  # @param [Array] np _Wz ((x,y), (x,y), ...)̌`œĂB
  # @param [Array] f0col hׂɎgFz
  # @param [Array] f1col hׂɎgFz
  # @param [Boolean] clip_enable trueȂʃTCY𒴂̕`Ȃ
  #
  def PolyFill.fill(img, np, f0col, f1col, clip_enable = true)

    return if np.size < 3

    # yW̍ŏlƍől߂
    ymin = ymax = np[0][1]
    np.each do |p|
      ymin = p[1] if ymin > p[1]
      ymax = p[1] if ymax < p[1]
    end

    if clip_enable
      ymin = 0 if ymin < 0
      ymax = Window.height if ymax > Window.height
    end

    if clip_enable
      # 1CXLĂ
      ymin.step(ymax, 1.0) do |y|
        xlst = PolyFill.get_intersection_point(y.to_f, np) # _xW߂
        next if xlst.empty? # _
        next if xlst.size % 2 != 0 # _
        i = 0
        while i < xlst.size
          x0, x1 = xlst[i], xlst[i+1]
          unless x1 < 0 or x0 > Window.width
            img.line(x0, y, x1, y, f0col)
          end
          i += 2
        end
      end
    else
      ymin.step(ymax, 1.0) do |y|
        xlst = PolyFill.get_intersection_point(y.to_f, np)
        next if xlst.empty? or xlst.size % 2 != 0
        i = 0
        while i < xlst.size
          img.line(xlst[i], y, xlst[i+1], y, f0col)
          i += 2
        end
      end
    end
  end

  # ^ꂽ_WzɂČ_Xg߂
  #
  # @param [Number] y XLyW
  # @param [Array] lst _Wz
  # @return [Array] _xWzŕԂ
  #
  def PolyFill.get_intersection_point(y, lst)
    xlst = []
    len = lst.size
    len.times do |i|
      x1, y1 = lst[i]
      x2, y2 = lst[(i + 1) % len]

      next if y1 == y2 # Ȃ珈Ȃ

      # yA݂̕ӂ̏I_ƁAӂ̎n_łA
      # ӂA܂͉̏ꍇ͌_珜O
      if y == y2
        y3 = lst[(i + 2) % len][1]
        next if (y2 - y1 < 0 and y3 - y2 < 0)
        next if (y2 - y1 > 0 and y3 - y2 > 0)
      end

      # yɂȂ悤ɓւ
      if y1 > y2
        x1, x2 = x2, x1
        y1, y2 = y2, y1
      end

      if y1 <= y and y <= y2
        # _ǉ
        x = ((y - y1) * (x2 - x1)).to_f / (y2 - y1) + x1
        xlst.push(x)
      end
    end

    # _Ƀ\[gĕԂ
    return xlst.sort
  end
end

if $0 == __FILE__
  # ----------------------------------------
  # eXg

  img = Image.new(640, 480)
  lst = [
    [200, 30],
    [300, 130],
    [350, 230],
    [300, 330],
    [200, 230],
    [50, 330],
    [100, 130],
    [200, 30]
  ]
  f0col = [255, 0, 255, 0]
  f1col = [255, 255, 0, 0]

  Window.loop do
    break if Input.keyPush?(K_ESCAPE)
    lst[4] = Input.mousePosX, Input.mousePosY
    img.clear
    PolyFill.fill(img, lst, f0col, f1col, false)
    Window.draw(0, 0, img)
  end
end
